var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Directive, HostBinding, Input, ElementRef } from '@angular/core';
import { HostClasses } from '../core/classes';
var MdaCard = (function () {
    function MdaCard(elementRef) {
        this.elementRef = elementRef;
        this.isFullWidth = false;
    }
    Object.defineProperty(MdaCard.prototype, "fill", {
        set: function (fill) {
            this.isFullWidth = fill !== false && fill !== null;
        },
        enumerable: true,
        configurable: true
    });
    MdaCard.prototype.ngAfterViewInit = function () { };
    return MdaCard;
}());
__decorate([
    HostBinding('class.umd-card--full-width'),
    __metadata("design:type", Object)
], MdaCard.prototype, "isFullWidth", void 0);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], MdaCard.prototype, "fill", null);
MdaCard = __decorate([
    HostClasses('umd-card'),
    Directive({
        selector: 'mda-card'
    }),
    __metadata("design:paramtypes", [ElementRef])
], MdaCard);
export { MdaCard };
var MdaCardText = (function () {
    function MdaCardText(elementRef) {
        this.elementRef = elementRef;
    }
    MdaCardText.prototype.ngAfterViewInit = function () { };
    return MdaCardText;
}());
MdaCardText = __decorate([
    HostClasses('umd-card-text umd-card--includes-padding'),
    Directive({
        selector: 'mda-card-text'
    }),
    __metadata("design:paramtypes", [ElementRef])
], MdaCardText);
export { MdaCardText };
var MdaCardMedia = (function () {
    function MdaCardMedia(elementRef) {
        this.elementRef = elementRef;
    }
    MdaCardMedia.prototype.ngAfterViewInit = function () { };
    return MdaCardMedia;
}());
MdaCardMedia = __decorate([
    HostClasses('umd-card-media'),
    Directive({
        selector: 'mda-card-media'
    }),
    __metadata("design:paramtypes", [ElementRef])
], MdaCardMedia);
export { MdaCardMedia };
var MdaCardTitle = (function () {
    function MdaCardTitle(elementRef) {
        this.elementRef = elementRef;
    }
    MdaCardTitle.prototype.ngAfterViewInit = function () { };
    return MdaCardTitle;
}());
MdaCardTitle = __decorate([
    HostClasses('umd-card-title umd-card--includes-padding'),
    Directive({
        selector: 'mda-card-title'
    }),
    __metadata("design:paramtypes", [ElementRef])
], MdaCardTitle);
export { MdaCardTitle };
var MdaCardSubtitle = (function () {
    function MdaCardSubtitle(elementRef) {
        this.elementRef = elementRef;
    }
    MdaCardSubtitle.prototype.ngAfterViewInit = function () { };
    return MdaCardSubtitle;
}());
MdaCardSubtitle = __decorate([
    HostClasses('umd-card-subtitle umd-card--includes-padding'),
    Directive({
        selector: 'mda-card-subtitle'
    }),
    __metadata("design:paramtypes", [ElementRef])
], MdaCardSubtitle);
export { MdaCardSubtitle };
var MdaCardActions = (function () {
    function MdaCardActions(elementRef) {
        this.elementRef = elementRef;
        this.isVertical = false;
    }
    Object.defineProperty(MdaCardActions.prototype, "vertical", {
        set: function (vertical) {
            this.isVertical = vertical !== false && vertical !== null;
        },
        enumerable: true,
        configurable: true
    });
    MdaCardActions.prototype.ngAfterViewInit = function () { };
    return MdaCardActions;
}());
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], MdaCardActions.prototype, "vertical", null);
__decorate([
    HostBinding('class.umd-card-actions--vertical'),
    __metadata("design:type", Object)
], MdaCardActions.prototype, "isVertical", void 0);
MdaCardActions = __decorate([
    HostClasses('umd-card-actions'),
    Directive({
        selector: 'mda-card-actions',
    }),
    __metadata("design:paramtypes", [ElementRef])
], MdaCardActions);
export { MdaCardActions };
var MdaCardMediaArea = (function () {
    function MdaCardMediaArea(elementRef) {
        this.elementRef = elementRef;
    }
    MdaCardMediaArea.prototype.ngAfterViewInit = function () { };
    return MdaCardMediaArea;
}());
MdaCardMediaArea = __decorate([
    HostClasses('umd-card-media-area'),
    Component({
        selector: 'mda-card-media-area',
        template: "\n        <div class=\"umd-card-media-area__content\">\n            <ng-content></ng-content>\n        </div>\n        <div class=\"umd-card-media-area__media\">\n            <ng-content select=\"[media]\"></ng-content>\n        </div>\n    "
    }),
    __metadata("design:paramtypes", [ElementRef])
], MdaCardMediaArea);
export { MdaCardMediaArea };
var MdaCardHeader = (function () {
    function MdaCardHeader(elementRef) {
        this.elementRef = elementRef;
    }
    MdaCardHeader.prototype.ngAfterViewInit = function () { };
    return MdaCardHeader;
}());
__decorate([
    Input(),
    __metadata("design:type", String)
], MdaCardHeader.prototype, "avatar", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], MdaCardHeader.prototype, "title", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], MdaCardHeader.prototype, "subtitle", void 0);
MdaCardHeader = __decorate([
    HostClasses('umd-card-header umd-card--includes-padding'),
    Component({
        selector: 'mda-card-header',
        template: "\n        <img class=\"umd-card-header__avatar\" [src]=\"avatar\" *ngIf=\"avatar\">\n        <div class=\"umd-card-header__titles\">\n            <h1>{{ title }}</h1>\n            <h2>{{ subtitle }}</h2>\n        </div>\n    "
    }),
    __metadata("design:paramtypes", [ElementRef])
], MdaCardHeader);
export { MdaCardHeader };
//# sourceMappingURL=card.js.map