import { ElementRef, Injector, Type, TemplateRef, ViewContainerRef, EventEmitter, OpaqueToken } from '@angular/core';
import { Portal } from '../core/portal';
export declare const MdaDialogArgs: OpaqueToken;
export declare class MdaDialog {
    private injector;
    constructor(injector: Injector);
    open<T>(component: Type<T> | TemplateRef<T>, args?: any): MdaDialogRef;
}
export declare class MdaDialogRef {
    private destroyFn;
    closed: EventEmitter<any>;
    constructor(destroyFn: () => void);
    close(value?: any): void;
}
export declare class MdaDialogContainer {
    private elementRef;
    private dialogRef;
    private viewRef;
    dialogElementRef: ElementRef;
    constructor(elementRef: ElementRef, dialogRef: MdaDialogRef, viewRef: ViewContainerRef);
    onClick(target: HTMLElement): void;
    attachPortal(portal: Portal): void;
    ngAfterViewInit(): void;
}
export declare class MdaDialogTitle {
    private elementRef;
    constructor(elementRef: ElementRef);
    ngAfterViewInit(): void;
}
export declare class MdaDialogContent {
    private elementRef;
    constructor(elementRef: ElementRef);
    ngAfterViewInit(): void;
}
export declare class MdaDialogActions {
    _: boolean;
    vertical: boolean;
    isVertical: boolean;
}
