var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, HostBinding, Input, TemplateRef, ViewContainerRef, ViewChild, Directive, HostListener, ElementRef, } from '@angular/core';
import { TemplatePortal } from '../core/portal';
var MdaMenu = (function () {
    function MdaMenu(viewRef) {
        this.viewRef = viewRef;
        this.position = 'top left';
        this.menuStyle = {
            position: 'absolute'
        };
    }
    Object.defineProperty(MdaMenu.prototype, "yPos", {
        get: function () {
            var yPos = this.position.split(' ')[0];
            return (yPos === 'top' || yPos === 'bottom') ? yPos : 'top';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MdaMenu.prototype, "xPos", {
        get: function () {
            var _a = this.position.split(' '), xPos = _a[1];
            return (xPos === 'left' || xPos === 'right') ? xPos : 'left';
        },
        enumerable: true,
        configurable: true
    });
    MdaMenu.prototype.ngAfterViewInit = function () {
        this.portal = new TemplatePortal(this.templateRef, this.viewRef);
    };
    MdaMenu.prototype.ngOnDestroy = function () {
        this.portal.detach();
    };
    MdaMenu.prototype.open = function (trigger) {
        if (trigger) {
            var bcr = this.getScreenRect(trigger);
            this.menuStyle[this.yPos] = bcr[this.yPos] + "px";
            this.menuStyle[this.xPos] = bcr[this.xPos] + "px";
            this.menuStyle['min-width'] = bcr.width + "px";
        }
        this.portal.attach(document.body);
    };
    MdaMenu.prototype.close = function () {
        this.portal.detach();
    };
    MdaMenu.prototype.containerClose = function (target) {
        if (target !== this.containerEl.nativeElement) {
            return;
        }
        this.close();
    };
    MdaMenu.prototype.getScreenRect = function (el) {
        var _a = el.getBoundingClientRect(), top = _a.top, left = _a.left, bottom = _a.bottom, right = _a.right, width = _a.width, height = _a.height;
        return {
            top: top, left: left, width: width, height: height,
            right: window.innerWidth - right,
            bottom: window.innerHeight - bottom,
        };
    };
    return MdaMenu;
}());
__decorate([
    ViewChild('template'),
    __metadata("design:type", TemplateRef)
], MdaMenu.prototype, "templateRef", void 0);
__decorate([
    ViewChild('container'),
    __metadata("design:type", ElementRef)
], MdaMenu.prototype, "containerEl", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], MdaMenu.prototype, "position", void 0);
MdaMenu = __decorate([
    Component({
        selector: 'mda-menu',
        exportAs: 'mdaMenu',
        template: "\n        <template #template>\n            <div #container class=\"umd-menu-container\" (click)=\"this.containerClose($event.target)\">\n                <div class=\"umd-menu\" [ngStyle]=\"menuStyle\" [style.transform-origin]=\"position\">\n                    <ng-content></ng-content>\n                </div>\n            </div>\n        </template>\n    "
    }),
    __metadata("design:paramtypes", [ViewContainerRef])
], MdaMenu);
export { MdaMenu };
var MdaMenuTrigger = (function () {
    function MdaMenuTrigger(elementRef) {
        this.elementRef = elementRef;
    }
    MdaMenuTrigger.prototype.toggleMenu = function () {
        this.menu.open(this.elementRef.nativeElement);
    };
    return MdaMenuTrigger;
}());
__decorate([
    Input('mdaMenuTrigger'),
    __metadata("design:type", MdaMenu)
], MdaMenuTrigger.prototype, "menu", void 0);
__decorate([
    HostListener('click'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], MdaMenuTrigger.prototype, "toggleMenu", null);
MdaMenuTrigger = __decorate([
    Directive({
        selector: '[mdaMenuTrigger]'
    }),
    __metadata("design:paramtypes", [ElementRef])
], MdaMenuTrigger);
export { MdaMenuTrigger };
var MdaMenuItem = (function () {
    function MdaMenuItem(menu) {
        this.menu = menu;
        this._ = true;
    }
    MdaMenuItem.prototype.onClick = function () {
        this.menu.close();
    };
    return MdaMenuItem;
}());
__decorate([
    HostBinding('class.umd-menu-item'),
    __metadata("design:type", Object)
], MdaMenuItem.prototype, "_", void 0);
__decorate([
    HostListener('click'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], MdaMenuItem.prototype, "onClick", null);
MdaMenuItem = __decorate([
    Component({
        selector: 'mda-menu-item',
        template: "\n        <ng-content></ng-content>\n        <mda-ripple></mda-ripple>\n    ",
    }),
    __metadata("design:paramtypes", [MdaMenu])
], MdaMenuItem);
export { MdaMenuItem };
//# sourceMappingURL=menu.js.map