var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, HostBinding, Input, ElementRef, EventEmitter, Output, ContentChildren, forwardRef, QueryList, HostListener, } from '@angular/core';
import { DomSanitizer } from '@angular/platform-browser';
var MdaTabBar = (function () {
    function MdaTabBar(elementRef, sanitizer) {
        this.elementRef = elementRef;
        this.sanitizer = sanitizer;
        this._ = true;
        this.variant = 'default';
        this.selected = 0;
        this.selectedChange = new EventEmitter();
        this.underlineTransform = 'scale(0)';
    }
    MdaTabBar.prototype.ngAfterContentInit = function () {
        var _this = this;
        if (this.tabLabels.length > this.selected) {
            requestAnimationFrame(function () { return _this.selectTab(_this.tabLabels.find(function (_, index) { return index === _this.selected; })); });
        }
    };
    MdaTabBar.prototype.selectTab = function (tabLabel) {
        var baseBcr = this.getBCR(this.elementRef);
        var bcr = this.getBCR(tabLabel.elementRef);
        var index = this.tabLabels.toArray().indexOf(tabLabel);
        this.underlineTransform = this.sanitizer.bypassSecurityTrustStyle("translateX(" + (bcr.left - baseBcr.left) + "px) scaleX(" + bcr.width + ")");
        this.selectedChange.next(index);
        this.tabLabels.forEach(function (label) { return label.active = false; });
        tabLabel.active = true;
    };
    MdaTabBar.prototype.getBCR = function (elementRef) {
        return elementRef.nativeElement.getBoundingClientRect();
    };
    return MdaTabBar;
}());
__decorate([
    HostBinding('class.umd-tab-bar'),
    __metadata("design:type", Object)
], MdaTabBar.prototype, "_", void 0);
__decorate([
    Input(),
    HostBinding('attr.data-umd-variant'),
    __metadata("design:type", String)
], MdaTabBar.prototype, "variant", void 0);
__decorate([
    Input(),
    __metadata("design:type", Number)
], MdaTabBar.prototype, "selected", void 0);
__decorate([
    Output(),
    __metadata("design:type", Object)
], MdaTabBar.prototype, "selectedChange", void 0);
__decorate([
    ContentChildren(forwardRef(function () { return MdaTabLabel; })),
    __metadata("design:type", QueryList)
], MdaTabBar.prototype, "tabLabels", void 0);
MdaTabBar = __decorate([
    Component({
        selector: 'mda-tab-bar',
        template: "\n        <ng-content></ng-content>\n        <div class=\"umd-tab-bar__underline\" [style.transform]=\"underlineTransform\"></div>\n    "
    }),
    __metadata("design:paramtypes", [ElementRef, DomSanitizer])
], MdaTabBar);
export { MdaTabBar };
var MdaTabLabel = (function () {
    function MdaTabLabel(elementRef, tabBar) {
        this.elementRef = elementRef;
        this.tabBar = tabBar;
        this._ = true;
        this.active = false;
    }
    MdaTabLabel.prototype.onClick = function () {
        this.tabBar.selectTab(this);
    };
    return MdaTabLabel;
}());
__decorate([
    HostBinding('class.umd-tab-label'),
    __metadata("design:type", Object)
], MdaTabLabel.prototype, "_", void 0);
__decorate([
    HostBinding('class.umd-tab-label--active'),
    __metadata("design:type", Object)
], MdaTabLabel.prototype, "active", void 0);
__decorate([
    HostListener('click'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], MdaTabLabel.prototype, "onClick", null);
MdaTabLabel = __decorate([
    Component({
        selector: 'mda-tab-label',
        template: "\n        <ng-content></ng-content>\n        <mda-ripple></mda-ripple>\n    "
    }),
    __metadata("design:paramtypes", [ElementRef, MdaTabBar])
], MdaTabLabel);
export { MdaTabLabel };
//# sourceMappingURL=tab.js.map