var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, forwardRef, Output, EventEmitter } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
export var MDA_INPUT_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(function () { return MdaTextField; }),
    multi: true,
};
var MdaTextField = (function () {
    function MdaTextField() {
        this.label = '';
        this.value = '';
        this.variant = 'default';
        this.autofocus = false;
        this.list = null;
        this.max = null;
        this.maxlength = null;
        this.min = null;
        this.minlength = null;
        this.name = null;
        this.readonly = false;
        this.required = false;
        this.spellcheck = false;
        this.step = null;
        this.tabindex = null;
        this.type = 'text';
        this.blur = new EventEmitter();
        this.focus = new EventEmitter();
        this.isDisabled = false;
        this.hasFocus = false;
        this.controlValueOnChange = function () { return undefined; };
        this.controlValueOnTouch = function () { return undefined; };
    }
    Object.defineProperty(MdaTextField.prototype, "disabled", {
        set: function (disabled) {
            this.isDisabled = disabled !== false && disabled !== null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MdaTextField.prototype, "isFloating", {
        get: function () {
            return this.hasFocus || !!this.value;
        },
        enumerable: true,
        configurable: true
    });
    MdaTextField.prototype.onFocus = function (evt) {
        this.hasFocus = true;
        this.focus.next(evt);
    };
    MdaTextField.prototype.onBlur = function (evt) {
        this.hasFocus = false;
        this.blur.next(evt);
        this.controlValueOnTouch();
    };
    Object.defineProperty(MdaTextField.prototype, "inputValue", {
        get: function () {
            return this.value;
        },
        set: function (value) {
            if (value !== this.value) {
                this.value = value;
                this.controlValueOnChange(value);
            }
        },
        enumerable: true,
        configurable: true
    });
    // ControlValueAccessor
    MdaTextField.prototype.writeValue = function (value) {
        this.value = value;
    };
    MdaTextField.prototype.registerOnChange = function (fn) {
        this.controlValueOnChange = fn;
    };
    MdaTextField.prototype.registerOnTouched = function (fn) {
        this.controlValueOnTouch = fn;
    };
    return MdaTextField;
}());
__decorate([
    Input(),
    __metadata("design:type", String)
], MdaTextField.prototype, "label", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], MdaTextField.prototype, "variant", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], MdaTextField.prototype, "autocomplete", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], MdaTextField.prototype, "autocorrect", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], MdaTextField.prototype, "autocapitalize", void 0);
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], MdaTextField.prototype, "autofocus", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], MdaTextField.prototype, "list", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], MdaTextField.prototype, "max", void 0);
__decorate([
    Input(),
    __metadata("design:type", Number)
], MdaTextField.prototype, "maxlength", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], MdaTextField.prototype, "min", void 0);
__decorate([
    Input(),
    __metadata("design:type", Number)
], MdaTextField.prototype, "minlength", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], MdaTextField.prototype, "name", void 0);
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], MdaTextField.prototype, "readonly", void 0);
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], MdaTextField.prototype, "required", void 0);
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], MdaTextField.prototype, "spellcheck", void 0);
__decorate([
    Input(),
    __metadata("design:type", Number)
], MdaTextField.prototype, "step", void 0);
__decorate([
    Input(),
    __metadata("design:type", Number)
], MdaTextField.prototype, "tabindex", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], MdaTextField.prototype, "type", void 0);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], MdaTextField.prototype, "disabled", null);
__decorate([
    Output(),
    __metadata("design:type", Object)
], MdaTextField.prototype, "blur", void 0);
__decorate([
    Output(),
    __metadata("design:type", Object)
], MdaTextField.prototype, "focus", void 0);
__decorate([
    Input('value'),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], MdaTextField.prototype, "inputValue", null);
MdaTextField = __decorate([
    Component({
        selector: 'mda-textfield',
        template: "\n        <label\n            class=\"umd-textfield\"\n            [attr.data-umd-variant]=\"variant\"\n            [class.umd-textfield--disabled]=\"isDisabled\"\n            [class.umd-textfield--focused]=\"hasFocus\">\n            <span\n                class=\"umd-textfield__label\"\n                [class.umd-textfield__label--floating]=\"isFloating\">\n                {{ label }}\n            </span>\n            <input\n                *ngIf=\"type !== 'textarea'\"\n                class=\"umd-textfield__input\"\n                [autofocus]=\"autofocus\"\n                [disabled]=\"disabled\"\n                [type]=\"type\"\n                [readonly]=\"readonly\"\n                [required]=\"required\"\n                [attr.autocomplete]=\"autocomplete\"\n                [attr.autocorrect]=\"autocorrect\"\n                [attr.autocapitalize]=\"autocapitalize\"\n                [attr.list]=\"list\"\n                [attr.max]=\"max\"\n                [attr.maxlength]=\"maxlength\"\n                [attr.min]=\"min\"\n                [attr.minlength]=\"minlength\"\n                [spellcheck]=\"spellcheck\"\n                [attr.step]=\"step\"\n                [attr.tabindex]=\"tabindex\"\n                [attr.name]=\"name\"\n                [(ngModel)]=\"inputValue\"\n                (focus)=\"onFocus($event)\"\n                (blur)=\"onBlur($event)\">\n            <textarea\n                *ngIf=\"type === 'textarea'\"\n                class=\"umd-textfield__input\"\n                [autofocus]=\"autofocus\"\n                [disabled]=\"disabled\"\n                [readonly]=\"readonly\"\n                [required]=\"required\"\n                [attr.autocomplete]=\"autocomplete\"\n                [attr.autocorrect]=\"autocorrect\"\n                [attr.autocapitalize]=\"autocapitalize\"\n                [attr.list]=\"list\"\n                [attr.max]=\"max\"\n                [attr.maxlength]=\"maxlength\"\n                [attr.min]=\"min\"\n                [attr.minlength]=\"minlength\"\n                [spellcheck]=\"spellcheck\"\n                [attr.step]=\"step\"\n                [attr.tabindex]=\"tabindex\"\n                [attr.name]=\"name\"\n                [(ngModel)]=\"inputValue\"\n                (focus)=\"onFocus($event)\"\n                (blur)=\"onBlur($event)\">\n            </textarea>\n            <span class=\"umd-textfield__underline\"></span>\n        </label>\n    ",
        providers: [MDA_INPUT_VALUE_ACCESSOR],
    })
], MdaTextField);
export { MdaTextField };
//# sourceMappingURL=textfield.js.map