import { Type, ViewContainerRef, Injector, ComponentRef, Provider, TemplateRef } from '@angular/core';
export interface Portal {
    attach(container: HTMLElement): void;
    detach(): void;
}
export declare class ComponentPortal<T> implements Portal {
    private component;
    compRef: ComponentRef<T>;
    injector: Injector;
    private viewRef;
    private destroy;
    constructor(component: Type<T>, injector: Injector);
    constructor(component: Type<T>, viewRef: ViewContainerRef);
    readonly instance: T;
    inject(...providers: Provider[]): void;
    attach(container: HTMLElement): void;
    detach(): void;
    private readonly factoryResolver;
    private readonly applicationRef;
    private create();
}
export declare class TemplatePortal<T> implements Portal {
    private templateRef;
    private viewRef;
    context: T;
    private view;
    constructor(templateRef: TemplateRef<T>, viewRef: ViewContainerRef, context?: T);
    attach(container: HTMLElement): void;
    detach(): void;
}
